﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace Facebook.Exceptions
{
    /// <summary>
    /// Base API Exception
    /// </summary>
    public class FacebookException : Exception 
    {

        public FacebookException(string message) : base(message) { }
    
    }

    /// <summary>
    /// In case it was not possible to load any configuration, it will throw an exception when 
    /// any method tries to access the Facebook API
    /// </summary>
    public class FacebookConfigException : FacebookException
    {

        public FacebookConfigException(string message) : base(message) { } 
    }

    /// <summary>
    /// If there is no Channel instatiated, then this exception will be thrown 
    /// </summary>
    public class FacebookChannelException : Exception 
    {
        public FacebookChannelException(string message) : base(message) { }
    }
}