﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Social.Core.Contracts
{
    /// <summary>
    /// Provides url format functionality
    /// </summary>
    public interface IRequestFormatter
    {
        /// <summary>
        /// Formats an url
        /// </summary>
        /// <param name="url"> url base </param>
        /// <param name="objectId">object id to request</param>
        /// <param name="args">arguments to add as query string parameters</param>
        /// <returns>the formatted url</returns>
        string FormatUrl(string url, string objectId, IDictionary<String, String> args);
    }

}
